"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _colors = require("../../styles/colors");

var _colors2 = _interopRequireDefault(_colors);

var _timing = require("../../styles/timing");

var _timing2 = _interopRequireDefault(_timing);

var _propTypes3 = require("../../utils/propTypes");

var _propTypes4 = _interopRequireDefault(_propTypes3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  backgroundColor: "transparent",
  color: _colors2.default.accentGray,
  cursor: "pointer",
  fontSize: "18px",
  padding: "5px",
  transition: "color " + _timing2.default.default + " ease-in-out",

  ":hover": { color: _colors2.default.linkPrimary },
  ":active": { color: _colors2.default.linkPrimary },
  ":focus": { color: _colors2.default.linkPrimary }
};

var CardActionIcon = function CardActionIcon(_ref) {
  var children = _ref.children,
      onClick = _ref.onClick,
      style = _ref.style;
  return _react2.default.createElement(
    "button",
    {
      style: [styles, style],
      onClick: onClick
    },
    children
  );
};

CardActionIcon.propTypes = {
  children: _propTypes2.default.node.isRequired,
  onClick: _propTypes2.default.func.isRequired,
  style: _propTypes4.default.style
};

exports.default = (0, _radium2.default)(CardActionIcon);